from tweepy.streaming import StreamListener
from tweepy import OAuthHandler
from tweepy import Stream
import tweepy
import json
import twitter
import configparser

from SendSMS import MessageHandler

config = configparser.ConfigParser()
config.read('../resources/config.ini')

consumer_key = config['TWITTER']['consumer_key']
consumer_secret = config['TWITTER']['consumer_secret']
access_token = config['TWITTER']['access_token']
access_token_secret = config['TWITTER']['access_token_secret']
base_url = config['API']['base_url']
app_key = config['API']['app_key']
app_secret = config['API']['app_secret']

messageHandler = MessageHandler(base_url, app_key, app_secret)

class StdOutListener(StreamListener):

    def __init__(self, api=None):
        self.api = api
        self.handleNumberMapping=load_properties('properties.txt')
        
    def on_status(self, status):
        #print status.author.id_str
        if status.author.id_str in follow_users_ids:
            "true"
            numbers=[]
            message = status.text
            message=message.replace("&amp;", "and")
            print message
            #Adds numbers for the handle names mentioned in the properties file
            for key, value in self.handleNumberMapping.iteritems():
                if key in message:
                    numbers.append(value)

            #message = "+".join(message.split(' '))
            for number in numbers:
                messageHandler.sendSMS(message, number)

    def on_error(self, status):
        print status

#Loads handle names and numbers mapping
def load_properties(filepath, sep='=', comment_char='#'):
    """
    Read the file passed as parameter as a properties file.
    """
    props = {}
    with open(filepath, "rt") as f:
        for line in f:
            l = line.strip()
            if l and not l.startswith(comment_char):
                key_value = l.split(sep)
                key = key_value[0].strip()
                value = sep.join(key_value[1:]).strip().strip('"') 
                props[key] = value 
    return props


if __name__ == '__main__':

    # This handles Twitter authentification and the connection to Twitter Streaming API
    l = StdOutListener()
    auth = OAuthHandler(consumer_key, consumer_secret)
    auth.set_access_token(access_token, access_token_secret)
    stream = Stream(auth, l)
    
    

    #Need to get user ids of users and copy here to capture their live feeds
    #Here these are our user ids , you can get them from https://tweeterid.com/
    follow_users_ids = [] #Replace with twitter ids
      
    stream.filter(follow=follow_users_ids)